From 7ab1e184ace945b94e8c014553eee5512d154156 Mon Sep 17 00:00:00 2001
From: Aurélien Bompard <aurelien@bompard.org>
Date: May 04 2017 22:05:20 +0000
Subject: [PATCH 829/1001] Add a way to override the fedmsg config file


---

diff --git a/check-queue-length.py b/check-queue-length.py
index 1a07f79..d6d90e9 100755
--- a/check-queue-length.py
+++ b/check-queue-length.py
@@ -17,8 +17,9 @@ from __future__ import unicode_literals, print_function
 
 import retask
 
-import fedmsg.config
-config = fedmsg.config.load_config()
+from hubs.utils import get_fedmsg_config
+
+config = get_fedmsg_config()
 
 for item in ['triage', 'work']:
     queue = retask.queue.Queue(config['hubs.redis.%s-queue-name' % item])
diff --git a/delete-user.py b/delete-user.py
index 9c79fc9..544f89e 100755
--- a/delete-user.py
+++ b/delete-user.py
@@ -6,11 +6,10 @@ Useful for testing what happens when you recreate them.
 
 from __future__ import unicode_literals, print_function
 
-import fedmsg.config
-
 import hubs.models
+from hubs.utils import get_fedmsg_config
 
-fedmsg_config = fedmsg.config.load_config()
+fedmsg_config = get_fedmsg_config()
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'])
 
diff --git a/hubs/app.py b/hubs/app.py
index 62a7485..fa24829 100644
--- a/hubs/app.py
+++ b/hubs/app.py
@@ -5,15 +5,13 @@ import logging
 import os
 
 import datanommer.models
-import fedmsg.config
-import fedmsg.meta
 import flask
 import flask.json
 import munch
 from flask_oidc import OpenIDConnect
 
 import hubs.models
-from hubs.utils import username2avatar
+from hubs.utils import get_fedmsg_config, username2avatar
 
 app = flask.Flask(__name__)
 
@@ -32,9 +30,7 @@ app.config.from_object('hubs.default_config')
 if 'HUBS_CONFIG' in os.environ:
     app.config.from_envvar('HUBS_CONFIG')
 
-fedmsg_config = fedmsg.config.load_config()
-fedmsg.meta.make_processors(**fedmsg_config)
-
+fedmsg_config = get_fedmsg_config()
 session = hubs.models.init(
     fedmsg_config.get('hubs.sqlalchemy.uri', 'sqlite:///'))
 datanommer.models.init(
diff --git a/hubs/tests/__init__.py b/hubs/tests/__init__.py
index ad600c0..90913f1 100644
--- a/hubs/tests/__init__.py
+++ b/hubs/tests/__init__.py
@@ -25,9 +25,6 @@ class APPTest(unittest.TestCase):
         self.vcr.__enter__()
 
         import hubs.app
-        hubs.app.fedmsg_config = {
-            'hubs.sqlalchemy.uri': 'sqlite://',  # in memory
-        }
         hubs.app.session = hubs.models.init(
             hubs.app.fedmsg_config['hubs.sqlalchemy.uri'],
             create=True,
@@ -36,9 +33,6 @@ class APPTest(unittest.TestCase):
         self.app = hubs.app.app.test_client()
         self.app.testing = True
         self.session = hubs.app.session
-        from hubs.widgets.caching import cache
-        cache.configure(backend='dogpile.cache.null',
-                        replace_existing_backend=True)
         self.populate()
 
     def tearDown(self):
diff --git a/hubs/tests/fedmsg_test.cfg b/hubs/tests/fedmsg_test.cfg
new file mode 100644
index 0000000..6d64bdf
--- /dev/null
+++ b/hubs/tests/fedmsg_test.cfg
@@ -0,0 +1,53 @@
+# Fedmsg configuration for testing
+
+config = {
+    #'hubs.consumer.enabled': True,
+    'hubs.sqlalchemy.uri': 'sqlite://',  # in memory
+
+    ## For communication between fedmsg-hub and the cache worker farm
+    #'hubs.redis.triage-queue-name': 'fedora-hubs-triage-queue',
+    #'hubs.redis.work-queue-name': 'fedora-hubs-work-queue',
+
+    ## Junk junk junk.. that we don't care about.  Drop it!
+    #'hubs.junk_suffixes': [
+    #    'buildsys.tag',
+    #    'buildsys.untag',
+    #    'buildsys.rpm.sign',
+    #],
+
+    'endpoints': {
+        "fedora-infrastructure": [
+            "tcp://hub.fedoraproject.org:9940",
+        ]
+    },
+
+    #'datanommer.sqlalchemy.uri':
+    #    'postgres://postgres:laksjdf@127.0.0.1/datanommer',
+
+    #'fmn.url': 'https://apps.fedoraproject.org/notifications',
+
+    ## Some configuration for the rule processors
+    #"fmn.rules.utils.use_pkgdb2": False,
+    #"fmn.rules.utils.pkgdb2_api_url": "http://209.132.184.188/api/",
+    #"fmn.rules.cache": {
+    #    "backend": "dogpile.cache.dbm",
+    #    "expiration_time": 300,
+    #    "arguments": {
+    #        "filename": "/var/tmp/fmn-cache.db",
+    #    },
+    #},
+
+    # No cache during testing.
+    "fedora-hubs.cache": {
+        "backend": "dogpile.cache.null",
+    },
+
+    ## Run datanommer locally, just for development.
+    #'datanommer.enabled': True,
+    #'datanommer.sqlalchemy.url':
+    #    'postgres://postgres:laksjdf@127.0.0.1/datanommer',
+
+    ## Only do one of these so we can try to not run out of memory.
+    #'moksha.workers_per_consumer': 1,
+}
+
diff --git a/hubs/utils.py b/hubs/utils.py
index 830d5ae..4fa5f1f 100755
--- a/hubs/utils.py
+++ b/hubs/utils.py
@@ -1,17 +1,29 @@
 from __future__ import unicode_literals
 
-import logging
-from hashlib import sha256
-
 import arrow
+import logging
 import markdown
+import os
 import requests
+from hashlib import sha256
 
+import fedmsg.config
+import fedmsg.meta
 from six.moves.urllib_parse import urlencode
 
 log = logging.getLogger(__name__)
 
 
+def get_fedmsg_config():
+    try:
+        filenames = [os.environ["FEDMSG_CONFIG"]]
+    except KeyError:
+        filenames = None
+    fedmsg_config = fedmsg.config.load_config(filenames=filenames)
+    fedmsg.meta.make_processors(**fedmsg_config)
+    return fedmsg_config
+
+
 def markup(text):
     return markdown.markdown(
         text,
diff --git a/hubs/widgets/caching.py b/hubs/widgets/caching.py
index c94dddb..acb18d5 100644
--- a/hubs/widgets/caching.py
+++ b/hubs/widgets/caching.py
@@ -9,14 +9,15 @@ from __future__ import unicode_literals
 import datetime
 import dogpile
 import dogpile.cache
-import fedmsg.config
 import logging
 
+from hubs.utils import get_fedmsg_config
+
+
 log = logging.getLogger(__name__)
 
 
 def _get_cache():
-    config = fedmsg.config.load_config()
     cache_defaults = {
         "backend": "dogpile.cache.dbm",
         "expiration_time": 1,  # Expire every 1 second, for development
@@ -25,7 +26,8 @@ def _get_cache():
         },
     }
     cache = dogpile.cache.make_region()
-    cache.configure(**config.get('fedora-hubs.cache', cache_defaults))
+    fedmsg_config = get_fedmsg_config()
+    cache.configure(**fedmsg_config.get('fedora-hubs.cache', cache_defaults))
     return cache
 
 
diff --git a/hubs/widgets/fedmsgstats/__init__.py b/hubs/widgets/fedmsgstats/__init__.py
index ac1ba24..56f5e40 100644
--- a/hubs/widgets/fedmsgstats/__init__.py
+++ b/hubs/widgets/fedmsgstats/__init__.py
@@ -5,12 +5,13 @@ import fedmsg.config
 import fedmsg.meta
 import requests
 
-from hubs.utils import commas
+from hubs.utils import get_fedmsg_config, commas
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
-fedmsg_config = fedmsg.config.load_config()
+
+fedmsg_config = get_fedmsg_config()
 
 
 class FedmsgStats(Widget):
diff --git a/hubs/widgets/github_pr/__init__.py b/hubs/widgets/github_pr/__init__.py
index c5970f9..283a15d 100644
--- a/hubs/widgets/github_pr/__init__.py
+++ b/hubs/widgets/github_pr/__init__.py
@@ -3,14 +3,14 @@ from __future__ import unicode_literals
 import logging
 import hubs.utils
 
+from hubs.utils import get_fedmsg_config
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
-import fedmsg.config
-fedmsg_config = fedmsg.config.load_config()
 
 log = logging.getLogger(__name__)
+fedmsg_config = get_fedmsg_config()
 
 
 class GitHubPRs(Widget):
diff --git a/hubs/widgets/subscriptions/__init__.py b/hubs/widgets/subscriptions/__init__.py
index d6dd928..05d0693 100644
--- a/hubs/widgets/subscriptions/__init__.py
+++ b/hubs/widgets/subscriptions/__init__.py
@@ -1,16 +1,17 @@
 from __future__ import unicode_literals
 
 import flask
-import hubs.models
+from fedmsg.meta import msg2usernames
+from fedmsg.meta.base import BaseConglomerator as BC
 
+import hubs.models
+from hubs.utils import get_fedmsg_config
 from hubs.widgets import validators
 from hubs.widgets.base import Widget, WidgetView
 from hubs.widgets.caching import CachedFunction
 
-from fedmsg.meta.base import BaseConglomerator as BC
 
-import fedmsg.config
-fm_config = fedmsg.config.load_config()
+fedmsg_config = get_fedmsg_config()
 
 
 class Subscriptions(Widget):
@@ -74,5 +75,5 @@ class GetSubs(CachedFunction):
         if not message['topic'].endswith('hubs.associate'):
             return False
         username = self.instance.config['username']
-        users = fedmsg.meta.msg2usernames(message, **fm_config)
+        users = msg2usernames(message, **fedmsg_config)
         return username in users
diff --git a/populate-from-fas.py b/populate-from-fas.py
index 6e9fb36..0771d24 100755
--- a/populate-from-fas.py
+++ b/populate-from-fas.py
@@ -7,11 +7,13 @@ import getpass
 import socket
 import string
 
+import fedora.client.fas2
+
 import hubs.models
+from hubs.utils import get_fedmsg_config
 
-import fedora.client.fas2
-import fedmsg.config
-fedmsg_config = fedmsg.config.load_config()
+
+fedmsg_config = get_fedmsg_config()
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
 fasclient = fedora.client.fas2.AccountSystem(
diff --git a/populate.py b/populate.py
index 08feaa3..1aa1c8b 100755
--- a/populate.py
+++ b/populate.py
@@ -7,9 +7,10 @@ import json
 
 import hubs.models
 import hubs.widgets
+from hubs.utils import get_fedmsg_config
 
-import fedmsg.config
-fedmsg_config = fedmsg.config.load_config()
+
+fedmsg_config = get_fedmsg_config()
 
 session = hubs.models.init(fedmsg_config['hubs.sqlalchemy.uri'], True, True)
 
diff --git a/tox.ini b/tox.ini
index 59d93a5..a6609a0 100644
--- a/tox.ini
+++ b/tox.ini
@@ -12,12 +12,12 @@ deps =
     -rtest-requirements.txt
 setenv =
     HUBS_CONFIG={toxinidir}/hubs/tests/hubs_test.cfg
+    FEDMSG_CONFIG={toxinidir}/hubs/tests/fedmsg_test.cfg
     PYTHONPATH={toxinidir}
 whitelist_externals =
     rm
 commands =
-    rm -f /var/tmp/fedora-hubs-cache.db*
-    nosetests --with-coverage --cover-erase {posargs:hubs}
+    nosetests --with-coverage --cover-erase {posargs:hubs.tests}
     coverage html
 
 [testenv:js]

